#include "Strings.h"

//    
char str_buffer[12];


struct divmod10_t
{
    uint32_t quot;
    uint8_t rem;
};


inline static struct divmod10_t divmodu10 (uint32_t n)
{
    struct divmod10_t res;
    //   0.8
    res.quot = n >> 1;
    res.quot += res.quot >> 1;
    res.quot += res.quot >> 4;
    res.quot += res.quot >> 8;
    res.quot += res.quot >> 16;
    uint32_t qq = res.quot;
    //   8
    res.quot >>= 3;
    //  
    res.rem = (uint8_t)(n - ((res.quot << 1) + (qq & ~7ul)));
    //    
    if(res.rem > 9)
    {
        res.rem -= 10;
        res.quot++;
    }
    return res;
}


//   32-    
//      (   )
//   0,   4294967295
//   11 : 10  +   
char* utoa (uint32_t value)
{
    char* buffer = str_buffer;
    buffer += 11;
    *--buffer = 0;
    do
    {
        struct divmod10_t res = divmodu10 (value);
        *--buffer = res.rem + '0';
        value = res.quot;
    }
    while (value != 0);
    return buffer;
}


//   32-    
//      (   )
//   -2147483648,   2147483647
//   12 : 10  +   +   
char* itoa (int32_t value)
{
    char* buffer = str_buffer;
    uint8_t minus = 0;
    if (value < 0)
    {
        value = -value;
        minus = 1;
    }
    buffer += 12;
    *--buffer = 0;
    do
    {
        struct divmod10_t res = divmodu10 (value);
        *--buffer = res.rem + '0';
        value = res.quot;
    }
    while (value != 0);
    if (minus) *--buffer = '-';
    return buffer;
}

