﻿/*
Программа для работы с дисплеем от кассового аппарата "Элвес-Микро-К".
Контроллер дисплея Holtek HT1621, тактируется от внутреннего RC-генератора.
Микроконтроллер ATmega48PA, тактовая частота 1 МГц.
Код написан в AVR Studio 5.1

Конфигурация фузов:
LOW  - 0x62
HIGH - 0xDF

Подключение дисплея к макетной плате
Дисплей ------------ ATmega
 1. GND ------------ GND
 2. +5V ------------ +5V
 3. DDAT ----------- PD4
 4. CLK ------------ PD3
 5. CHARGE
 6. ACCLO
 7. DRES (CS) ------ PD5
 8. +5V ------------ +5V
 9. NC
10. NC

Автор: Шутов Максим [Zlodey]
masya-chel@mail.ru
https://vk.com/zateykin
Best regards to Kolhoz-Devices Inc.
kdevices@mail.ru
г.Москва
Май 2020 г.
*/


#include "main.h"


int main (void)
{
	// Инициализация последовательной шины
	Serial_Bus_Init();
	// Инициализация дисплея
	Display_Init();
	
	// Примеры работы с дисплеем
	
	// Включить пищалку
	Display_Buzzer_On();
	// Пищим 50 мс
	_delay_ms(50);
	// Отключить пищалку
	Display_Buzzer_Off();
	
	// Включить подсветку
	Display_Backlight_On();
	
	while(1)
	{
		// Демонстрация возможностей отображения дисплея
		Display_Clear();
		Display_Test();
		Display_Update();
		_delay_ms(2000);
		
		// Пример отображения температуры
		Display_Clear();
		Display_SNum (0, -23);
		Display_Sym (3, SYM_DEGREE);
		Display_SNum (5, 45);
		Display_Sym (7, SYM_DEGREE);
		Display_Update();
		_delay_ms(2000);
		
		// Пример отображения времени
		Display_Clear();
		Display_Num (2, 23);
		Display_Div (3, Double);
		Display_Num (4, 45);
		Display_Update();
		_delay_ms(2000);
		
		// Пример отображения числа
		Display_Clear();
		Display_Num(0,67509813);
		Display_Update();
		_delay_ms(2000);
	}
}

